// SimpleCtrl.cpp : Implementation of CSimpleCtrl

#include "stdafx.h"
#include "Atltest.h"
#include "SimpleCtrl.h"

/////////////////////////////////////////////////////////////////////////////
// CSimpleCtrl


STDMETHODIMP CSimpleCtrl::get_DisplayString(BSTR *pVal)
{
	// TODO: Add your implementation code here
	*pVal = m_DisplayString.Copy();
	return S_OK;
}

STDMETHODIMP CSimpleCtrl::put_DisplayString(BSTR newVal)
{
	// TODO: Add your implementation code here
	m_DisplayString = newVal;
    // Ʈ   Ѵ. 
    SetDirty(TRUE);
    //  ̳ʿ Ѵ. 
    FireViewChange();
	return S_OK;
}

IWebBrowser2* CSimpleCtrl::GetWeb()
{
    CComPtr<IOleClientSite> pClientSite;
    CComPtr<IOleContainer> pContainer;
    CComPtr<IServiceProvider> pServiceProvider;

    IWebBrowser2* pIWB2;

    GetClientSite( &pClientSite );
	if(pClientSite == NULL)
		return NULL;

    pClientSite->GetContainer( &pContainer );
    if(pContainer->QueryInterface( &pServiceProvider ) != S_OK)
		return NULL;

	// Active X Control IE ÷  ƴϴ п 
    if( pServiceProvider->QueryService( SID_SWebBrowserApp, IID_IWebBrowser2, (void**) &pIWB2 ) != S_OK)
		return NULL;

	return pIWB2;
}

#include <mshtml.h>
#pragma warning(disable : 4146)	//see Q231931 for explaintation
bool CSimpleCtrl::CallJavaScript(char* szID)
{
	if(GetWeb() == NULL)
		return false;

	IWebBrowser2*  piWebBrowser = m_iWeb;
	CComPtr<IDispatch> pDisp;


	HRESULT hr = piWebBrowser->get_Document(&pDisp); 
	if (FAILED(hr) || pDisp == NULL)
		return false;

	CComPtr<IHTMLDocument2>	pDoc;
	hr = pDisp->QueryInterface(IID_IHTMLDocument2,(void**)&pDoc);
	
	if (pDoc == NULL)
		return false;

	// Evaluate is the name of the script function. 
	CComBSTR  szMember("ShowMsg"); 
	DISPID dispid = NULL; 

	CComPtr<IDispatch> spScript;
	hr = pDoc->get_Script(&spScript);
	if(FAILED(hr))
	{
		//ShowError("Cannot GetScript");
		return false;
	}

	hr = spScript->GetIDsOfNames(IID_NULL, &szMember, 1, LOCALE_SYSTEM_DEFAULT, &dispid); 
	if (SUCCEEDED(hr)) 
	{  
		EXCEPINFO excepInfo;
		memset(&excepInfo, 0, sizeof excepInfo);
  		CComVariant vaResult;
		UINT nArgErr = (UINT)-1;      // initialize to invalid arg
  
	    //Putting parameters
	    DISPPARAMS dispparams;
	    memset(&dispparams, 0, sizeof dispparams);
	    dispparams.cArgs      = 1;
	    dispparams.rgvarg     = new VARIANT[1];
		{
			CComBSTR bstr(szID);
			bstr.CopyTo(&dispparams.rgvarg[0].bstrVal);
			dispparams.rgvarg[0].vt = VT_BSTR;
		}
	    dispparams.cNamedArgs = 0;

		hr = spScript->Invoke(dispid, IID_NULL, LOCALE_SYSTEM_DEFAULT, 	DISPATCH_METHOD, 
												&dispparams, &vaResult, &excepInfo, &nArgErr);
		delete [] dispparams.rgvarg;
		if(FAILED(hr))
		{
			//ShowError(GetSystemErrorMessage(hr));
			return false;
		}
	} 

	return true;
}

